<?php
/**
 * is_deleted 1 = true, 0 = false
 * action -1 = downvote, 1 = upvote
 * type 1 = post, 2 = comment
 */
function uvdv_db_create_table(){
	global $wpdb, $jal_db_version;
	$table_name = $wpdb->prefix . "pg_uvdv_ips";
	if($wpdb->get_var("show tables like '$table_name'") != $table_name){
		$sql = "CREATE TABLE " . $table_name . " (
		ID int(9) NOT NULL AUTO_INCREMENT,
		sub_id int(9) DEFAULT 0 NOT NULL,
		user_id int(9) DEFAULT 0,
		ip varchar(255) DEFAULT '' NOT NULL,		
		name varchar(255) DEFAULT '' NOT NULL,
		email_address varchar(255) DEFAULT '' NOT NULL,		
		url varchar(255) DEFAULT '' NOT NULL,
		type int DEFAULT 0 NOT NULL,
		action int DEFAULT 0 NOT NULL,
		time int(20) DEFAULT 0 NOT NULL,
		is_deleted int DEFAULT 0 NOT NULL,
		UNIQUE KEY id (ID)
		);";
		require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
		dbDelta($sql);
		add_option("jal_db_version", $jal_db_version);
	}
	else{
		$data = get_plugin_data(UVDV_FILE, true, true);
		switch($data['Version']){
			case '1.0.0':
				$wpdb->show_errors;
				$query= 'ALTER TABLE ' . $table_name . ' add column name varchar(200) DEFAULT "" AFTER ip';
				$wpdb->query($query);
				$query= 'ALTER TABLE ' . $table_name . ' add column email_address varchar(200) DEFAULT "" AFTER name';
				$wpdb->query($query);
				$query= 'ALTER TABLE ' . $table_name . ' add column url varchar(200) DEFAULT "" AFTER email_address';
				$wpdb->query($query);
				$query= 'ALTER TABLE ' . $table_name . ' add column time int(20) DEFAULT '.time().' AFTER action';
				$wpdb->query($query);				
			//case '1.0.1':			
		}
		
	}
	
}

function uvdv_db_add_voter($params, $id = ''){
	global $wpdb;	
	$table_name = $wpdb->prefix . "pg_uvdv_ips";
	$fields = array();
	$values = array();
	foreach($params as $key => $value){
	
		$fields[] = $key;
		$values[] = '"' . $value . '"';
	}
	
	$sql = 'INSERT INTO ' . $table_name . ' ('. implode(', ', $fields) .') VALUES ('.implode(', ', $values).')';
	//echo $sql;
	$res = $wpdb->query($sql);
	if($id != '') $id = $wpdb->insert_id;
	$wpdb->show_errors();
	if($res == 1){
		return true;
	}
	return false;
}

function uvdv_db_update_vote($ID, $params){
	global $wpdb;	
	$table_name = $wpdb->prefix . "pg_uvdv_ips";
	
	$set = array();
	foreach($params as $key => $value){	
		$set[] = $key . ' = "' . $value . '"';
	}
	
	$sql = 'UPDATE ' . $table_name . ' SET ' . implode(', ', $set) . ' WHERE ID = "'.$ID.'"';
	//echo $sql;
	$wpdb->show_errors();
	$res = $wpdb->query($sql);
	if($res == 1){
		return true;
	}
	return false;
}

function uvdv_delete_voter($id){
	global $wpdb;	
	$table_name = $wpdb->prefix . "pg_uvdv_ips";
	$sql = 'UPDATE ' . $table_name . ' SET is_deleted = "1" WHERE ID = '.$id;
	$res = $wpdb->query($sql);
	if($res == 1){
		return true;
	}
	return false;
}

/**
 * $type 1 = post | 2 = comments
 * $action 0 = either | 1 = votes up | -1 votes down
 */
function uvdv_db_get_voters($type, $subid, $action = 0){
	global $wpdb;	
	$table_name = $wpdb->prefix . "pg_uvdv_ips";
	if($action == 1 || $action == -1)
		$sql = 'SELECT * FROM ' . $table_name . ' WHERE type = "' . $type . '" AND sub_id = "' . $subid . '" AND action = "' . $action . '" AND is_deleted = 0';
	else
		$sql = 'SELECT * FROM ' . $table_name . ' WHERE type = "' . $type . '" AND sub_id = "' . $subid . '" AND is_deleted = 0';
		
	$sql .= ' ORDER BY time DESC';
	
	$arr = $wpdb->get_results($sql, 'ARRAY_A');
	//echo $sql;
	if($arr == null) $arr = array();
	return $arr;
}

?>