<?php
/*
Plugin Name: WP Voting Wiz
Plugin URI: http://onlinesuccesswithchris.com
Description: Allows visitors and subscribers to vote on page, post, and comment content to gauge the effectiveness of your blog or website material. | <a href="../wp-content/plugins/wp-voting-wiz/WP-Voting-Wiz_UserManual_v2.1.pdf" title="PDF WP Voting Wiz User Manual" target="_blank">PDF User Manual</a> | <a href="../wp-content/plugins/wp-voting-wiz/WP-Voting-Wiz_UserManual_v2.1-readme.txt" title="WP Voting Wiz Readme Text File" target="_blank">Readme File</a> |
Version: 2.1
Author: Chris Jenkins
Author URI: http://onlinesuccesswithchris.com
*/

include_once('includes/view.php');
include_once('includes/lang_en.php');
include_once('includes/functions.php');

define('UVDV_BASEPATH', str_replace('\\', '/', WP_PLUGIN_DIR . '/' . basename(dirname(__FILE__)) . '/'));
define('UVDV_BASEURL', str_replace('\\', '/', WP_PLUGIN_URL . '/' . basename(dirname(__FILE__)) . '/'));
define('UVDV_AJAXURL', UVDV_BASEURL . '/includes/ajax.php');
define('UVDV_MAINSLUG', 'pg-upvote-downvote');
define('UVDV_FILE', __FILE__);

wp_enqueue_script('jquery');
wp_enqueue_script('uvdv-script', UVDV_BASEURL . '/includes/scripts.js');
wp_enqueue_style('uvdv-style', UVDV_BASEURL . '/includes/style.css');

function uvdv_statistics_pages(){
	uvdv_statistics_posts(true);
}

add_action('template_redirect', 'uvdv_filter_post');

function uvdv_filter_post(){
	$arr = get_option('pg-uvdv-settings');
	if($arr['manual'] != 'true'){
		global $wp_query, $post;
		
		$count_up = get_post_meta($post->ID, 'pg-voteup', true);
		$count_down = get_post_meta($post->ID, 'pg-votedown', true);	
		$text = '<a title="Vote Up" href="#" id="'.$post->ID.'"class="vote-up-post">'.(($count_up == '') ? '0':$count_up).'</a>';
		$text .= ' <a title="Vote Down" href="#" id="'.$post->ID.'" class="vote-down-post">'.(($count_down == '') ? '0':$count_down).'</a>';
		$votediv = '<div class="pgupdv">'.$text.'</div>';		
		$post->post_content = $post->post_content.$votediv;
	}
}

function uvdv_manual_on_posts(){
	$arr = get_option('pg-uvdv-settings');
	global $wp_query, $post;
	if($arr['manual'] == 'true'){
		global $wp_query, $post;
		
		$count_up = get_post_meta($post->ID, 'pg-voteup', true);
		$count_down = get_post_meta($post->ID, 'pg-votedown', true);	
		$text = '<a title="Vote Up" href="#" id="'.$post->ID.'"class="vote-up-post">'.(($count_up == '') ? '0':$count_up).'</a>';
		$text .= ' <a title="Vote Down" href="#" id="'.$post->ID.'" class="vote-down-post">'.(($count_down == '') ? '0':$count_down).'</a>';
		$votediv = '<div class="pgupdv">'.$text.'</div>';		
		echo $votediv;
	}
}

function uvdv_manual_on_comments(){
	$arr = get_option('pg-uvdv-settings');
	if($arr['manual-comment'] == 'true'){
		global $comment;
		global $current_user;
		$user_data = $current_user->data;
		
		$count_up = get_comment_meta($comment->comment_ID, 'pg-voteup', true);
		$count_down = get_comment_meta($comment->comment_ID, 'pg-votedown', true);
		$text = '<a title="Vote Up" href="#" id="'.$comment->comment_ID.'"class="vote-up">'.(($count_up == '') ? '0':$count_up).'</a>';
		$text .= ' <a title="Vote Down" href="#" id="'.$comment->comment_ID.'" class="vote-down">'.(($count_down == '') ? '0':$count_down).'</a>';
		echo '<div class="pgupdv">'.$text.'</div>';	
	}
}

add_action('admin_menu', 'uvdv_menu');

function uvdv_menu(){
	$v = new UvdvViews();
	add_menu_page(UVDV_TITLE, UVDV_TITLE, 'administrator', UVDV_MAINSLUG, 'uvdv_main_page', UVDV_BASEURL . 'images/pg-logo.png');
	add_submenu_page(UVDV_MAINSLUG, UVDV_STATPOSTS, UVDV_STATPOSTS, 'administrator', 'uvdv-statistics-posts', 'uvdv_statistics_posts');
	add_submenu_page(UVDV_MAINSLUG, UVDV_STATPAGES, UVDV_STATPAGES, 'administrator', 'uvdv-statistics-pages', 'uvdv_statistics_pages');
	add_submenu_page(UVDV_MAINSLUG, UVDV_STATCOMMENTS, UVDV_STATCOMMENTS, 'administrator', 'uvdv-statistics-comments', 'uvdv_statistics_comments');
}

function uvdv_statistics_comments(){
?>
<div class="wrap">
<?php
$pid = $_GET['uvdv-comment-id'];
if($pid == ''){
?>

	<div class="icon32 icon32-posts-post" id="pgudvote"><br></div>
	<h2>Statistics &raquo; Comments</h2>
	<table class="widefat" cellspacing="0">
		<thead>
			<tr>
				<!--<th style="" width="15%"><input type="checkbox"></th>-->
				<th style="" width="6%" class="">Comment ID</th>
				<th style="" width="10%" class="">Upvotes</th>
				<th style="" width="10%" class="">Downvotes</th>
				<th style="" width="20%" class="">Recent IP</th>
				<th style="" width="15%" class="">Actions</th>
			</tr>
		</thead>
		<tfoot>
			<tr>
				<!--<th style="" width="15%"><input type="checkbox"></th>-->
				<th style="" width="6%" class="">Comment ID</th>
				<th style="" width="10%" class="">Upvotes</th>
				<th style="" width="10%" class="">Downvotes</th>
				<th style="" width="20%" class="">Recent IP</th>
				<th style="" width="15%" class="">Actions</th>

			</tr>
		</tfoot>
		<tbody>
		<?php
		
		$hasmore = true;
		$perpage = 1;
		$ctr = 0;
		while($hasmore){
			$args = array(
			'number'		=> $perpage,
			'offset'		=> $perpage * $ctr,
			'orderby'		=> 'comment_ID',
			'order'			=> 'DESC',			
			'status'		=> 'approve');
			$posts_array = get_comments( $args );
			foreach($posts_array as $p){
				$count_up = get_comment_meta($p->comment_ID, 'pg-voteup', true);
				$count_down = get_comment_meta($p->comment_ID, 'pg-votedown', true);			
				if($count_up == 0 && $count_down == 0) continue;
		?>
			<tr valign="top" class=""  id="tab-<?php echo $p->comment_ID; ?>">
				<!--<th><input type="checkbox" value="1" name="post[]"></th>-->
				<td class=""><a href=""><?php echo $p->comment_ID; ?></a></td>
				<td class="">
				<?php

					echo '<div class="admin-pgupdv"><a title="Vote Up" class="vote-up">'.(($count_up == '') ? '0':$count_up).'</a></div>';				
				?>
				</a>	
				<td class="">
				<?php
				echo '<div class="admin-pgupdv"><a title="Vote Down" class="vote-down">'.(($count_down == '') ? '0':$count_down).'</a></div>';
				?>
				</td>
				<td class=""><?php
					$v = uvdv_db_get_voters(2, $p->comment_ID, 0);
					foreach($v as $_v){
						echo '<p>'.$_v['ip'].'</p>';
						break;
					}
				?></td>
				<td class="">
					<a href="admin.php?page=uvdv-statistics-comments&uvdv-comment-id=<?php echo $p->comment_ID; ?>">Details</a> | 
					<a target="_blank" href="<?php echo get_permalink($p->comment_post_ID).'#comment-'.$p->comment_ID; ?>">View Comment </a>
				</td>
			</tr>
		<?php 
			}
			$ctr++;
			if(count($posts_array) < $perpage) $hasmore = false;
		}?>	
		</tbody>
	</table>
<?php
	}
	else{
?>
		<div class="icon32 icon32-posts-post" id="pgudvote"><br></div>
		<h2>Statistics &raquo; Comments</h2>
<?php		
		$p = get_comment($pid);
		if($_POST['action'] == 'update'){
			if(is_array($_POST['ip'])){
				foreach($_POST['ip'] as $ipid => $on){
					uvdv_delete_voter($ipid);
				}
			}
			$voteup = $_POST['vote-up'];
			$votedown = $_POST['vote-down'];
			
			update_comment_meta($pid, 'pg-voteup', ($voteup != '') ? $voteup : 0);
			update_comment_meta($pid, 'pg-votedown', ($votedown != '') ? $votedown : 0);
			echo '<div id="message" class="updated below-h2"><p>Changes saved.</p></div>';
		}
		?>
		<form method="POST" action="">

		<div class="uvdv-statistics">
		<p>
			<label>Comment ID</label>
			<?php echo $p->comment_ID?>
		</p>
		<div class="">
			<label>Votes Up</label>
		<?php
			$count_up = get_comment_meta($p->comment_ID, 'pg-voteup', true);
			$count_down = get_comment_meta($p->comment_ID, 'pg-votedown', true);	
		?>
			<input type="text" name="vote-up" value="<?php echo ($count_up == '') ? '0':$count_up ?>" >
		</div>	
		<div class="ip-addresses">
			<label>Ip Addresses</label>
			<?php
			$v = uvdv_db_get_voters(2, $p->comment_ID, 1);
			if(count($v) > 0){
				?>
				<table class="widefat" width="100%">
					<tr>
						<td>Delete</td>
						<td>Name</td>
						<td>Email Address</td>
						<td>URL</td>
						<td>IP Address</td>
					</tr>				
				<?php
				foreach($v as $_v){
					if($_v['user_id'] != 0){
						$user = get_userdata($_v['user_id']);
						if($user->first_name == '' && $user->last_name == '')
							$name = $user->user_login;
						else
							$name = $user->first_name.' '.$user->last_name;	
						$email_address = $user->user_email;
						$url = $user->user_url;		
					}
					else{
						$name = $_v['name'];
						$email_address = $_v['email_address'];
						$url = $_v['url'];
					}
					?>
					<tr>
						<td><input type="checkbox" name="ip[<?php echo $_v['ID']; ?>]"></td>
						<td><?php echo $name; ?></td>
						<td><?php echo $email_address; ?></td>
						<td><a href="<?php echo $url; ?>" target="_blank"><?php echo $url; ?></a></td>
						<td><?php echo '<a href="'.rtrim(get_admin_url(), '/').'/edit-comments.php?s='.$_v['ip'].'&mode=detail">'.$_v['ip'].'</a>'; ?></td>
					</tr>
					<?php
				}
				?>
				</table>
				<?php
			}
			else{
				echo '<p><em>None</em></p>';
			}
		?></div>
		
		<div class="">
		<label>Votes Down</label>
		<input type="text" name="vote-down" value="<?php echo (($count_down == '') ? '0':$count_down); ?>" >
		</div>
		<div class="ip-addresses">
			<label>Ip Addresses</label>
		<?php
			$v = uvdv_db_get_voters(2, $p->comment_ID, -1);
			if(count($v) > 0){
				?>
				<table class="widefat">
					<tr>
						<td>Delete</td>
						<td>Name</td>
						<td>Email Address</td>
						<td>URL</td>
						<td>IP Address</td>
					</tr>
				<?php
				foreach($v as $_v){
					if($_v['user_id'] != 0){
						$user = get_userdata($_v['user_id']);
						if($user->first_name == '' && $user->last_name == '')
							$name = $user->user_login;
						else
							$name = $user->first_name.' '.$user->last_name;	
						$email_address = $user->user_email;
						$url = $user->user_url;		
					}
					else{
						$name = $_v['name'];
						$email_address = $_v['email_address'];
						$url = $_v['url'];
					}
					?>
					<tr>
						<td><input type="checkbox" name="ip[<?php echo $_v['ID']; ?>]"></td>
						<td><?php echo $name; ?></td>
						<td><?php echo $email_address; ?></td>
						<td><a href="<?php echo $url; ?>" target="_blank"><?php echo $url; ?></a></td>				
						<td><?php echo '<a href="'.rtrim(get_admin_url(), '/').'/edit-comments.php?s='.$_v['ip'].'&mode=detail">'.$_v['ip'].'</a>'; ?></td>
					</tr>
					<?php
				}
				?>
				</table>
				<?php				

			}
			else{
				echo '<p><em>None</em></p>';
			}
				
		?></div>	
		</div>
		<input type="hidden" name="action" value="update" />
		<div class="submit">
			<input type="submit" class="button-primary" value="Update" />
			<a  href="admin.php?page=uvdv-statistics-comments" class="button">Back</a>
			<a class="button" target="_blank" href="<?php echo get_permalink($p->comment_post_ID).'#comment-'.$p->comment_ID; ?>">View Comment </a> &nbsp;
		</div>
		</form>
		<?php
	}
?>	
</div>	
<?php	
}

function uvdv_statistics_posts($isPage = false){
$title = ($isPage) ? 'Statistics &raquo; Pages' : 'Statistics &raquo; Posts';
$baseurl = ($isPage) ? 'admin.php?page=uvdv-statistics-pages' : 'admin.php?page=uvdv-statistics-posts';
?>
<div class="wrap">
<?php
$pid = $_GET['uvdv-post-id'];
if($pid == ''){
?>
	<div class="icon32 icon32-posts-post" id="pgudvote"><br></div>
	<h2><?php echo $title; ?></h2>
	<table class="widefat" cellspacing="0">
		<thead>
			<tr>
				<!--<th style="" width="15%"><input type="checkbox"></th>-->
				<th style="" width="6%" class="">Post ID</th>
				<th style="" width="19%" class="">Post Title</th>
				<th style="" width="10%" class="">Upvotes</th>
				<th style="" width="10%" class="">Downvotes</th>
				<th style="" width="20%" class="">Recent IP</th>
				<th style="" width="15%" class="">Actions</th>
			</tr>
		</thead>
		<tfoot>
			<tr>
				<!--<th style="" width="15%"><input type="checkbox"></th>-->
				<th style="" width="6%" class="">Post ID</th>
				<th style="" width="14%" class="">Post Title</th>
				<th style="" width="10%" class="">Upvotes</th>
				<th style="" width="10%" class="">Downvotes</th>
				<th style="" width="20%" class="">Recent IP</th>
				<th style="" width="20%" class="">Actions</th>

			</tr>
		</tfoot>
		<tbody>
		<?php
		
		$hasmore = true;
		$perpage = 5;
		$ctr = 0;
		$post_type = ($isPage) ? 'page' : 'post';
		while($hasmore){
			$args = array(
			'numberposts'		=> $perpage,
			'offset'			=> $perpage * $ctr,
			'post_type'			=> $post_type,
			'orderby'			=> 'ID',
			'order'				=> 'DESC',				
			'post_status'		=> 'publish');
			$posts_array = get_posts( $args );
			foreach($posts_array as $p){
				$count_up = get_post_meta($p->ID, 'pg-voteup', true);
				$count_down = get_post_meta($p->ID, 'pg-votedown', true);	
				if($count_up == 0 && $count_down == 0) continue;
		?>
			<tr valign="top" class=""  id="tab-<?php echo $a['ID']; ?>">
				<!--<th><input type="checkbox" value="1" name="post[]"></th>-->
				<td class=""><?php echo $p->ID?></td>
				<td class=""><a target="_blank" href="<?php echo get_permalink($p->ID); ?>"><?php echo $p->post_title; ?></a></td>
				<td class="">
				<?php
					echo '<div class="admin-pgupdv"><a title="Vote Up" class="vote-up">'.(($count_up == '') ? '0':$count_up).'</a></div>';				
				?>
				</a>	
				<td class="">
				<?php
				echo '<div class="admin-pgupdv"><a title="Vote Down" class="vote-down">'.(($count_down == '') ? '0':$count_down).'</a></div>';
				?>
				</td>
				<td class=""><?php
					$v = uvdv_db_get_voters(1, $p->ID, 0);
					foreach($v as $_v){
						echo '<p>'.$_v['ip'].'</p>';
						break;
					}
				?></td>
				<td class="">
					<a href="<?php echo $baseurl; ?>&uvdv-post-id=<?php echo $p->ID; ?>">Details</a>
				</td>
			</tr>
		<?php 
			}
			$ctr++;
			if(count($posts_array) < $perpage) $hasmore = false;
		}?>	
		</tbody>
	</table>
<?php
	}
	else{		
		$p = get_post($pid);		
		?>
		<div class="icon32 icon32-posts-post" id="pgudvote"><br></div>
		<h2><?php echo $title; ?></h2>
		<?php
			if($_POST['action'] == 'update'){
				if(is_array($_POST['ip'])){
					foreach($_POST['ip'] as $ipid => $on){
						uvdv_delete_voter($ipid);
					}
				}
				$voteup = $_POST['vote-up'];
				$votedown = $_POST['vote-down'];
				
				update_post_meta($pid, 'pg-voteup', ($voteup != '') ? $voteup : 0);
				update_post_meta($pid, 'pg-votedown', ($votedown != '') ? $votedown : 0);
				echo '<div id="message" class="updated below-h2"><p>Changes saved.</p></div>';
			}
		?>		
		<form method="post">
		<div class="uvdv-statistics">
		<p>
			<label>Post ID</label>
			<?php echo $p->ID?>
		</p>
		<p>
			<label>Post Title</label>
			<a target="_blank" href="<?php echo get_permalink($p->ID); ?>"><?php echo $p->post_title; ?></a>
		</p>
		<div class="">
			<label>Votes Up</label>
		<?php
			$count_up = get_post_meta($p->ID, 'pg-voteup', true);
			$count_down = get_post_meta($p->ID, 'pg-votedown', true);			
		?>
		<input type="text" name="vote-up" value="<?php echo ($count_up == '') ? '0':$count_up ?>" >
		</div>	
		<div class="ip-addresses">
			<label>Ip Addresses</label>
			<?php
			$v = uvdv_db_get_voters(1, $p->ID, 1);
			
			if(count($v) > 0){
			?>
			<table class="widefat">
				<tr>
					<td>Delete</td>
					<td>Name</td>
					<td>Email Address</td>
					<td>URL</td>
					<td>IP Address</td>
				</tr>
			<?php			
				foreach($v as $_v){
					if($_v['user_id'] != 0){
						$user = get_userdata($_v['user_id']);
						if($user->first_name == '' && $user->last_name == '')
							$name = $user->user_login;
						else
							$name = $user->first_name.' '.$user->last_name;	
						$email_address = $user->user_email;
						$url = $user->user_url;		
					}
					else{
						$name = $_v['name'];
						$email_address = $_v['email_address'];
						$url = $_v['url'];
					}
					?>
					<tr>
						<td><input type="checkbox" name="ip[<?php echo $_v['ID']; ?>]"></td>
						<td><?php echo $name; ?></td>
						<td><?php echo $email_address; ?></td>
						<td><a href="<?php echo $url; ?>" target="_blank"><?php echo $url; ?></a></td>		
						<td><?php echo '<a href="'.rtrim(get_admin_url(), '/').'/edit-comments.php?s='.$_v['ip'].'&mode=detail">'.$_v['ip'].'</a>'; ?></td>
					</tr>
					<?php
					
				}
				?>
				</table>
				<?php
			}
			else{
				echo '<p><em>None</em></p>';
			}
		?></div>
		
		<div class="">
		<label>Votes Down</label>
		<input type="text" name="vote-down" value="<?php echo ($count_down == '') ? '0':$count_down ?>" >
		</div>
		<div class="ip-addresses">
			<label>Ip Addresses</label>
		<?php
			$v = uvdv_db_get_voters(1, $p->ID, -1);

			if(count($v) > 0){		
			?>
			<table class="widefat">
				<tr>
					<td>Delete</td>
					<td>Name</td>
					<td>Email Address</td>
					<td>URL</td>
					<td>IP Address</td>
				</tr>
			<?php			
				foreach($v as $_v){
					if($_v['user_id'] != 0){
						$user = get_userdata($_v['user_id']);
						if($user->first_name == '' && $user->last_name == '')
							$name = $user->user_login;
						else
							$name = $user->first_name.' '.$user->last_name;	
						$email_address = $user->user_email;
						$url = $user->user_url;		
					}
					else{
						$name = $_v['name'];
						$email_address = $_v['email_address'];
						$url = $_v['url'];
					}
					?>
					<tr>
						<td><input type="checkbox" name="ip[<?php echo $_v['ID']; ?>]"></td>
						<td><?php echo $name; ?></td>
						<td><?php echo $email_address; ?></td>
						<td><a href="<?php echo $url; ?>" target="_blank"><?php echo $url; ?></a></td>				
						<td><?php echo '<a href="'.rtrim(get_admin_url(), '/').'/edit-comments.php?s='.$_v['ip'].'&mode=detail">'.$_v['ip'].'</a>'; ?></td>
					</tr>
					<?php
					
				}
				?>
				</table>
				<?php
			}
			else{
				echo '<p><em>None</em></p>';
			}				
		?></div>	
		</div>
		<input type="hidden" name="action" value="update" />
		<div class="submit">
			<input type="submit" class="button-primary" value="Update" />		
			<a  href="<?php echo $baseurl; ?>" class="button">Back</a>
		</div>
		</form>
		<?php
	}
?>	
</div>	
<?php	
}

function uvdv_main_page(){
?>
<div class="wrap">
	<div class="icon32 icon32-posts-post" id="pgudvote"><br></div>
	<h2>WP Voting Wiz</h2>
	<?php
		if($_POST['form-name'] == 'uvdv-settings'){
			$arr['manual'] = $_POST['uvdv-manual'];
			$arr['manual-comment'] = $_POST['uvdv-manual-comment'];
			update_option('pg-uvdv-settings', $arr);
			echo '<div class="updated below-h2" id="message"><p>Changes saved.</p></div>';
		}
		
		$arr = get_option('pg-uvdv-settings');
	?>
	<form name="" method="post" class="uvdv-settings">
		<p>
			<input type="checkbox" id="uvdv-manual" name="uvdv-manual" value="true" <?php echo ($arr['manual'] == 'true') ? 'checked="checked"' : ''; ?>/>
			Append to post template manually.
		</p>
		<div class="for-templates">
			<p>
				Copy the text below on post template.</p>
			<p>
				<textarea readonly="readonly"><?php echo htmlentities('<?php uvdv_manual_on_posts(); ?>'); ?></textarea></p>
		</div>		
		<p>
			<input type="checkbox" id="uvdv-manual-comment" name="uvdv-manual-comment" value="true" <?php echo ($arr['manual-comment'] == 'true') ? 'checked="checked"' : ''; ?>/>
			Append to comment template manually.
		</p>
		<div class="for-comment-template">
			<p>Copy on text below on comment template.</p>
			<p>
				<textarea readonly="readonly"><?php echo htmlentities('<?php uvdv_manual_on_comments(); ?>'); ?></textarea>
			</p>
		</div>
		<input type="hidden" name="form-name" value="uvdv-settings" />
		<div class="submit">
			<input type="submit" class="button-primary" value="Save Changes" />
		</div>
	</form>
</div>
<?php
}

/** modify comment and add upvote and downvote button */
add_action('wp_head', 'uvdv_filter_comment');

function uvdv_filter_comment(){
	$arr = get_option('pg-uvdv-settings');
	if($arr['manual-comment'] != 'true'){
		add_filter('comment_text', 'uvdv_comment_text', 8002);
	}
}

function uvdv_comment_text($comment_text){
	global $comment;
	global $current_user;
	$user_data = $current_user->data;
	
	$count_up = get_comment_meta($comment->comment_ID, 'pg-voteup', true);
	$count_down = get_comment_meta($comment->comment_ID, 'pg-votedown', true);
	$text = '<a title="Vote Up" href="#" id="'.$comment->comment_ID.'"class="vote-up">'.(($count_up == '') ? '0':$count_up).'</a>';
	$text .= ' <a title="Vote Down" href="#" id="'.$comment->comment_ID.'" class="vote-down">'.(($count_down == '') ? '0':$count_down).'</a>';
	return $comment_text.'<div class="pgupdv">'.$text.'</div>';	
}

/** add new columns on comments table */
add_action('manage_comments_custom_column', 'uvdv_custom_column', 10, 2);

function uvdv_custom_column($column_name, $id){
	if( $column_name == 'pg-votes' ) {
		$count_up = get_comment_meta($id, 'pg-voteup', true);
		$count_down = get_comment_meta($id, 'pg-votedown', true);
		$text = '<a title="Vote Up" class="vote-up">'.(($count_up == '') ? '0':$count_up).'</a>';
		$text .= ' <a title="Vote Down" class="vote-down">'.(($count_down == '') ? '0':$count_down).'</a>';		
		echo '<div class="admin-pgupdv">'.$text.'</div>';
	}
}

//add_filter('manage_edit-comments_columns', 'uvdv_columns');

function uvdv_columns($defaults) {
	$defaults['pg-votes'] = "Votes";	
	return array_merge($defaults);
}

/** add new column on posts table */
function uvdv_columns_head($defaults) {  
	$defaults['pg-votes'] = 'Votes';  
	return $defaults;  
}  
  
function uvdv_columns_content($column_name, $id) {  
	if( $column_name == 'pg-votes' ) {
		$count_up = get_post_meta($id, 'pg-voteup', true);
		$count_down = get_post_meta($id, 'pg-votedown', true);
		$text = '<a title="Vote Up" class="vote-up">'.(($count_up == '') ? '0':$count_up).'</a>';
		$text .= ' <a title="Vote Down" class="vote-down">'.(($count_down == '') ? '0':$count_down).'</a>';		
		echo '<div class="admin-pgupdv">'.$text.'</div>';
	}}  

//add_filter('manage_posts_columns', 'uvdv_columns_head');
//add_filter('manage_posts_custom_column', 'uvdv_columns_content', 10, 2);

/** ajax to handle user clicks on upvote and downvote button*/

/**
 * define ajaxurl
 */
add_action('wp_head','uvdv_define_ajaxurl');

function uvdv_define_ajaxurl() {
?>
<script type='text/javascript'>var ajaxurl = '<?php echo admin_url("admin-ajax.php"); ?>';</script>
<?php
} 

/**
 * $value eg. IP Value: 127.0.0.1 | User ID Value: 1
 * $type 'ip' or 'userid'
 * $postid post id
 */
function canVoteOnComment($type, $value, $cid){
	echo "Type: ".$type;
	if($type == 'ip'){
		$cookie_name = getCommentIPCookieName($value, $cid);
	}
	else if($type == 'userid'){
		$cookie_name = getCommentUserIDCookieName($value, $cid);
	}
	else
		return false;
	//echo "Type: >>".$type." Cookie name : ".$cookie_name." VALUE>>".$_COOKIE[$cookie_name];
	if($_COOKIE[$cookie_name] != null)
		return false;
	else
		return true;	
}

/**
 * $value eg. IP Value: 127.0.0.1 | User ID Value: 1
 * $type 'ip' or 'userid'
 * $postid post id
 */
function canVoteOnPost($type, $value, $postid){
	if($type == 'ip'){
		$cookie_name = getPostIPCookieName($value, $postid);
	}
	else if($type == 'userid'){
		$cookie_name = getPostUserIDCookieName($value, $postid);
	}
	else
		return false;
	
	if($_COOKIE[$cookie_name] == 'true')
		return false;
	else
		return true;	
}

function getPostIPCookieName($ip, $postid){
	return 'pg-voted-ip-'.str_replace('.', '', $ip).'-post-'.$postid;
}

function getPostUserIDCookieName($userid, $postid){
	return 'pg-voted-user-'.$userid.'-post-'.$postid;
}

function getCommentIPCookieName($ip, $cid){
	return 'pg-voted-ip-'.str_replace('.', '', $ip).'-comment-'.$cid;
}

function getCommentUserIDCookieName($userid, $cid){
	return 'pg-voted-user-'.$userid.'-comment-'.$cid;;
}
/**
 * $_POST['CID'] - comment id
 * $_POST['action'] - up for vote up, download for vote down
 */
function uvdv_ajax() {
	global $current_user;
	$year = 27594000;
	$action = $_POST['action2'];
	$value= 'true';
	
	$user_data = $current_user->data;
	$params = array();
	$ip = $_SERVER['REMOTE_ADDR']; //get ip	
	if($user_data == null){
		if($_POST['CID'] != ''){ //on comment
			$name = getCommentIPCookieName($ip, $_POST['CID']); //name = pg-voted-ip-{uid}-comment-{cid} | value = true e.g. pg-vote-user-5-comment-102
			$params['sub_id'] = $_POST['CID'];
			$params['ip'] = $ip;
			$params['type'] = 2;
		}
		else{ //on post
			$name = getPostIPCookieName($ip, $_POST['PID']);
			$params['sub_id'] = $_POST['PID'];
			$params['ip'] = $ip;
			$params['type'] = 1;			
		}
		$commenter = wp_get_current_commenter();
		$params['name'] = $commenter['comment_author'];
		$params['url'] = $commenter['comment_author_url'];
		$params['email_address'] = $commenter['comment_author_email'];
		
	}
	
	else{
		$params['user_id'] = $user_data->ID;
		if($_POST['CID'] != ''){ //on comment
			$name = getCommentUserIDCookieName($user_data->ID,$_POST['CID']); //name = pg-voted-ip-{uid}-comment-{cid} | value = true e.g. pg-vote-user-5-comment-102
			$params['sub_id'] = $_POST['CID'];
			$params['ip'] = $ip;
			$params['type'] = 2;			
		}
		else{ //post
			$name = getPostUserIDCookieName($user_data->ID,$_POST['PID']);
			$params['sub_id'] = $_POST['PID'];
			$params['ip'] = $ip;
			$params['type'] = 1;				
		}
	}
	
	
	if($_COOKIE[$name] == "true"){
		exit;
	}
	else{
		setCookie($name, $value, time()+($year), '/');//cookie ip
		if($action == 'up'){
			if($_POST['CID'] != ''){ //on comment
				$count_up = get_comment_meta($_POST['CID'], 'pg-voteup', true);
				$count_up++;
				update_comment_meta($_POST['CID'], 'pg-voteup', $count_up);
				echo $count_up;
			}
			else{ //on post
				$count_up = get_post_meta($_POST['PID'], 'pg-voteup', true);
				$count_up++;
				update_post_meta($_POST['PID'], 'pg-voteup', $count_up);
				echo $count_up;		
			}
			$params['action'] = 1;
		}
		else if($action == 'down'){
			if($_POST['CID'] != ''){ //on comment
				$count_down = get_comment_meta($_POST['CID'], 'pg-votedown', true);
				$count_down++;
				update_comment_meta($_POST['CID'], 'pg-votedown', $count_down);
				echo $count_down;
			}
			else{ //on post
				$count_down = get_post_meta($_POST['PID'], 'pg-votedown', true);
				$count_down++;
				update_post_meta($_POST['PID'], 'pg-votedown', $count_down);
				echo $count_down;		
			}
			$params['action'] = -1;
		}
	}

	
	$params['time'] = time();
	uvdv_db_add_voter($params);
	exit;
}

add_action('wp_ajax_uvdv_ajax', 'uvdv_ajax');
add_action('wp_ajax_nopriv_uvdv_ajax', 'uvdv_ajax');//for users that are not logged in.

register_activation_hook(__FILE__,'uvdv_activate');

function uvdv_activate(){
	uvdv_db_create_table();
}

?>